#include <Arduino.h>

inline void digitalWriteDirect(int pin, boolean val){
  if(val) g_APinDescription[pin].pPort -> PIO_SODR = g_APinDescription[pin].ulPin;
  else    g_APinDescription[pin].pPort -> PIO_CODR = g_APinDescription[pin].ulPin;
}

unsigned long lastB;
unsigned long B;
float st;
int jc = 0,np,sc;
float aa[10],d1[10],d2[10],qr0[4],qr1[4],qr2[4];
float bb[10],e1[10],e2[10],w0[10],w1[10],w2[10];

void get_biquad(float, float *, float *, float * );
void startTimer(Tc , uint32_t , IRQn_Type , uint32_t ,int ); 
int abufc=0, abuf[100];


#define PP 3281

void startTimer(Tc *tc, uint32_t channel, IRQn_Type irq, uint32_t frequency,int ttype) 
// type = 1 for slow timers, supply frequency in Hz. type = 2 for fast timers, supply period in clocks
{
        uint32_t rc=0;
        pmc_set_writeprotect(false);
        pmc_enable_periph_clk((uint32_t)irq);
        if (ttype == 1)
          {
          TC_Configure(tc, channel, TC_CMR_WAVE | TC_CMR_WAVSEL_UP_RC | TC_CMR_TCCLKS_TIMER_CLOCK4);
          rc = VARIANT_MCK/128/frequency; //128 because we selected TIMER_CLOCK4 above
          }
        if (ttype == 2)
          {
            TC_Configure(tc, channel, TC_CMR_WAVE | TC_CMR_WAVSEL_UP_RC );
            rc = frequency; 
          }
        TC_SetRA(tc, channel, rc/2); //50% high, 50% low
        TC_SetRC(tc, channel, rc);
        TC_Start(tc, channel);
        tc->TC_CHANNEL[channel].TC_IER=TC_IER_CPCS;
        tc->TC_CHANNEL[channel].TC_IDR=~TC_IER_CPCS;
        NVIC_EnableIRQ(irq);
}


void setup() 
{
int i;
// init adc sample buffer
for(i=0; i < 100; i++)
	abuf[i]=0;
abufc=0;
ADC->ADC_MR |= 0x80;  //set free running mode on ADC
ADC->ADC_CHER = 0xf0; //enable ADC on low 4 inputs

analogWrite(DAC0,0);
analogWrite(DAC1,0);
pmc_set_writeprotect(false);
pmc_enable_periph_clk((uint32_t)TC0_IRQn);
pmc_enable_periph_clk((uint32_t)TC8_IRQn);
PIO_Configure(PIOD,PIO_PERIPH_B,PIO_PD8B_TIOB8,PIO_DEFAULT);
PIO_Configure(PIOD,PIO_PERIPH_B,PIO_PD7B_TIOA8,PIO_DEFAULT);
REG_TC2_WPMR=0x54494D00;
TC_Configure(TC2, 2,!TC_CMR_WAVE|TC_CMR_TCCLKS_TIMER_CLOCK1|TC_CMR_LDRB_RISING|TC_CMR_LDRA_FALLING);
TC2->TC_CHANNEL[2].TC_IER=TC_IER_LDRBS;
TC2->TC_CHANNEL[2].TC_IMR=TC_IMR_LDRBS;
TC_Start(TC2, 2);
NVIC_EnableIRQ(TC8_IRQn);
startTimer(TC1, 0, TC3_IRQn,16800 ,2);    // 84e6 Hz clock/(100*50) to call it 100 times per 50 Hz
Serial.begin(115200);
np = 4;
get_biquad(0.03,aa,d1,d2);
get_biquad(0.03,bb,e1,e2);
sc=0;
pinMode(7, OUTPUT);
pinMode(8, OUTPUT);
}


void loop() 
{
float t, smag, fmag;
int i;
long tsamp=0,mag;
if ((B - lastB) > 800000)
  {
	tsamp = 0;
	for(i=0; i < 100; i++)
		tsamp += (long)abuf[i];
	tsamp /= 100;
	mag=0;
	for(i=0; i < 100; i++)
		mag += (abuf[i] - tsamp) * (abuf[i] - tsamp);
	fmag = sqrt((float)mag);
	
    t = 42e6 / (float)(B - lastB);
    for(i=0; i<np; ++i)
      {
      qr0[i] = d1[i]*qr1[i] + d2[i]*qr2[i] + t;
      st = aa[i]*(qr0[i] + 2.0*qr1[i] + qr2[i]);
      qr2[i] = qr1[i];
      qr1[i] = qr0[i];
      }

for(i=0; i<np; ++i)
      {
      w0[i] = e1[i]*w1[i] + e2[i]*w2[i] + fmag;
      smag = bb[i]*(w0[i] + 2.0*w1[i] + w2[i]);
      w2[i] = w1[i];
      w1[i] = w0[i];
      }


     digitalWriteDirect(8, HIGH);          
     digitalWriteDirect(8, LOW); 
     sc++;
     if (sc > 40)
        {
          sc=0; 
          Serial.print(" 495 500 505 ");
          Serial.print(st*10.0);
          Serial.print(" ");
          Serial.println(smag/52.1);
        }
  }
delay(10);
}


void TC3_Handler()
{
TC_GetStatus(TC1, 0);
abuf[abufc] = ADC->ADC_CDR[7];
abufc++;
if (abufc >= 100)
	abufc = 0;
}



void TC8_Handler()
{
TC_GetStatus(TC2, 2);
lastB=B;
B = TC2->TC_CHANNEL[2].TC_RB;
digitalWriteDirect(7, HIGH);          
digitalWriteDirect(7, LOW); 
}

void get_biquad(float fc, float aa[], float d1[], float d2[])
  {
  float s,r;
  int i;
  float a = tan(M_PI*fc);
  float a2 = a*a;
  for(i=0; i<np; ++i)
    {
    r =  sin(3.141592926 * (2.0*i+1.0)/(4.0*np));
    s = a2 + 2.0*a*r + 1.0;
    aa[i] = a2/s;
    d1[i] = 2.0*(1-a2)/s;
    d2[i] = -(a2 - 2.0*a*r + 1.0)/s;
    }
  }
